﻿Public Class clpForm

	Dim inhTyp As String = ""
	Dim lastTyp As String = ""
	Dim lastInh As Object = Nothing
	Dim inhObj As Object = Nothing
	Private theIcon As Icon

	Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) _
		Handles Timer1.Tick
		inhTyp = testClipboard() '-----------
		inhObj = readClipboard(inhTyp)
		'prüfen, ob sich Clipboard-Inhalt geändert hat
		If (lastInh Is Nothing) OrElse Not (lastInh.Equals(inhObj)) Then
			txtShow.Visible = False
			picShow.Visible = False
			lblShow.Visible = False
			audioGo.Visible = False
			audioStop.Visible = False
			'prüfen des Typs des Clipboard-Inhalts
			Select Case inhTyp
				Case "img"	'Bild, Image
					With picShow
						.ClientSize = Me.ClientSize
						.Image = readClipboard(inhTyp)
						.Visible = True
						.Location = New Point(0, ToolStrip1.Bottom)
					End With
				Case "aud"	'Audiofile
					audioGo.Visible = True
					audioStop.Visible = True
					If My.Computer.Clipboard.ContainsAudio Then
						Dim audio As System.IO.Stream
						audio = readClipboard(inhTyp)
						My.Computer.Audio.Play(audio, AudioPlayMode.WaitToComplete)
					End If
				Case "fdl"	'File-Liste
					Dim filelist As System.Collections.Specialized.StringCollection
					filelist = My.Computer.Clipboard.GetFileDropList()
					With txtShow
						.Text = ""
						.Dock = DockStyle.Fill
						For Each filePath As String In filelist
							.Text += filePath + vbCrLf
						Next
						.Visible = True
					End With
				Case "dat"	'nicht spezifiziert
					With lblShow
						.Text = "Datentyp ist nicht näher spezifiziert."
						.Dock = DockStyle.Top
						.Visible = True
					End With
				Case "txt"	'Text
					With txtShow
						.Dock = DockStyle.Fill
						.Text = readClipboard(inhTyp) '----------------
						.Visible = True
					End With
				Case "not"	'Clipboard ist leer
					With lblShow
						.Text = "Momentan kein Inhalt in der Zwischenablage."
						.Dock = DockStyle.Top
						.Visible = True
					End With
			End Select
			lastInh = inhObj
		End If
	End Sub

	Private Sub clpForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) _
		Handles MyBase.Load
		'Controls unsichtbar machen
		txtShow.Visible = False
		picShow.Visible = False
		lblShow.Visible = False
		audioGo.Visible = False
		audioStop.Visible = False
	End Sub

	Sub PlayBackgroundSoundFile(ByVal audioFile As String)
		'Audio-File abspielen
		My.Computer.Audio.Play(audioFile, AudioPlayMode.Background)
	End Sub

	Sub StopBackgroundSound()
		'Audio-File stoppen
		My.Computer.Audio.Stop()
	End Sub

	Private Sub ToolStripButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
		Handles ToolStripButton1.Click
		'Font für Textanzeige auswählen
		If FontDialog1.ShowDialog() = DialogResult.OK Then
			txtShow.Font = FontDialog1.Font
			lblShow.Font = FontDialog1.Font
		End If
	End Sub

	Private Sub audioGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
		Handles audioGo.Click
		PlayBackgroundSoundFile("")
	End Sub

	Private Sub audioStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
		Handles audioStop.Click
		StopBackgroundSound()
	End Sub

	Private Sub ToolStripButton2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
		Handles ToolStripButton2.Click
		'Clipboard-Inhalt löschen
		My.Computer.Clipboard.Clear()
	End Sub


	'überprüfen, was sich in der Zwischenablage befindet
	Private Function testClipboard()
		Dim cTyp As String
		With My.Computer.Clipboard
			If .ContainsImage Then
				cTyp = "img"
			ElseIf .ContainsAudio Then
				cTyp = "aud"
			ElseIf .ContainsFileDropList Then
				cTyp = "fdl"
			ElseIf .ContainsData("specialFormat") Then
				cTyp = "dat"
			ElseIf .ContainsText Then
				cTyp = "txt"
			Else
				cTyp = "not"
			End If
		End With
		Return cTyp
	End Function

	'lesen aus der Zwischenablage
	Private Function readClipboard(ByVal cTyp As String) As Object
		Dim obj As Object
		With My.Computer.Clipboard
			Select Case cTyp
				Case "img"
					obj = .GetImage
				Case "aud"
					obj = .GetAudioStream
				Case "fdl"
					obj = .GetFileDropList
				Case "dat"
					obj = .GetData("specialFormat")
				Case "txt"
					obj = .GetText
				Case Else
					obj = Nothing
			End Select
		End With
		Return obj
	End Function

End Class
